% Ground truth clicker for mouse_pad
% 
% q ........ quit
% a ........ previous file
% d ........ following file
% , ........ run backwards
% . ........ run forwards
% space .... stop
% e ........ edit (click four corners of the object starting at the left upper corner continuing in clock-wise direction)



data.filePath = './mouse_pad/';
data.filePrefix = 'img_';
data.filePostfix = '.jpg';
data.fileCiphers = 5;
data.fileFirst = 2358;
data.fileLast = 7045;



h = figure(1);
% p = get(0,'ScreenSize'); set(h,'Position',p); 
set(h,'Name','"q"-quit, "a"-previous, "d"-following, ","-backward, "."-forward, "space"-stop, "e"-edit')
%for i = data.fileFirst:(data.fileFirst + data.fileNum),
i = data.fileFirst; running = false; step = 1;

while true;    
    
    U = load([data.filePath, data.filePrefix, num2normstr(i,data.fileCiphers),'.txt'],'-ASCII');
    im = mean(double(imread([data.filePath, data.filePrefix, num2normstr(i,data.fileCiphers), data.filePostfix])),3)/255;  
    imshow(im); hold on;    title([num2str(i),'/',num2str(data.fileLast)]);
    h_border = line([U(2,:) U(2,1)], [U(1,:) U(1,1)]); set(h_border,'Color', 'red', 'MarkerSize',8,'LineWidth',3); 
    for j=1:size(U,2), text(U(2,j), U(1,j),num2str(j),'FontSize',30,'Color','black'); end; hold off; drawnow;
    if ~running,
    w = waitforbuttonpress;
    if w==1,
        b =  get(h,'currentCharacter');        
        switch b
            case 'q', break;
            case 'a', if i>data.fileFirst, i = i - 1; end;                             % one frame backward
            case 'd', if i<data.fileLast, i = i + 1; end;                              % one frame forward    
            case ',', step = -1; running = true;                                       % run backward
            case '.', step = 1; running = true;                                        % run forward
            case 'e',                                                                  % edit
                X = ginput(4); U = [X(:,2) X(:,1)]';
                save([data.filePath, data.filePrefix, num2normstr(i,data.fileCiphers),'.txt'],'U','-ASCII');
                imshow(im); hold on;    title([num2str(i),'/',num2str(data.fileLast)]);
                h_border = line([U(2,:) U(2,1)], [U(1,:) U(1,1)]); set(h_border,'Color', 'red', 'MarkerSize',8,'LineWidth',3); 
                for j=1:size(U,2), text(U(2,j), U(1,j),num2str(j),'FontSize',25,'Color','white'); end; hold off; drawnow;
        end;
    end;
    else
        b = get(h,'currentCharacter');
        if b==' ',
            running = false;
        else
           if ((i+step)>=data.fileFirst)&&((i+step)<=data.fileLast), 
               i = i + step; 
           else
               running = false; 
           end;
        end;
    end;        
end;
disp('program terminated')
